;
(function($, w, app) {
	var dow = {};
	dow.element = null;
	//监听下载
	function onStateChanged(download, status) {
		var total = download.totalSize;
		var realSize = download.downloadedSize;
		var Percentage = (realSize / total)*100;
		var integer=0;
		if(status==404)
		{
			mui.toast("下载失败");
			return;
		}
		if(download.state == 2) {
			download.id = dow.element;
		}
		if(download.state == 3) {
				download.id.innerHTML = Percentage.toFixed(2) + "%";
		}
		if(download.state == 4 && status == 200) {
			// 下载完成 
			if(plus.os.name=="Android")
			{
					console.log("下载完成" + download.id.innerHTML + "文件路径" + download.filename);
				plus.runtime.install(download.filename, true, function(Info) {
					console.log("appid" + Info.appid + "\n版本" + Info.version + "\n名称" + Info.name + "\n描述" + Info.description + "\n应用授权" + Info.license + "\n应用许可" + Info.features);
					var gameinfo = {};
					gameinfo.name = Info.name;
					gameinfo.path = download.filename;
					gameinfo.version = Info.version;
					gameinfo.urlId=dow.urlId;
					//直接默认没有安装
						gameinfo.state =2;
						download.id.removeAttribute("disabled");
						download.id.setAttribute("data-state", "2");
						download.id.innerHTML = "下载";
						console.log("下载完成了 进行缓存"+download.id.innerHTML);
						saveGameinfo(gameinfo);
						//添加安装监听
						listenInstall(gameinfo,download.id)
					//isInstall(Info.name)
				}, function() {
					mui.toast("安装失败！");
					download.id.removeAttribute("disabled");
				});
			}else if(plus.os.name=="iOS")
			{
				//TODO 还没有测试的苹果
				var UIApplication = plus.ios.importClass("UIApplication");
				var NSURL = plus.ios.importClass("NSURL");
				
				var app = UIApplication.sharedApplication();
				var bdScheme = NSURL.URLWithString("baidumap://");
				var install = app.canOpenURL(bdScheme);
				
				plus.ios.deleteObject(bdScheme);
				plus.ios.deleteObject(app);
			}
		
		}
	}
	// 创建下载任务
	function createDownload(info) {
		console.log(JSON.stringify(info))
		dtask = plus.downloader.createDownload(info.href);
		console.log("查看链接地址"+info.href)
		dtask.addEventListener("statechanged", onStateChanged, false);
		dtask.start();
		//				enumerate();
	}
	// 暂停下载任务 
	function pauseDownload() {
		dtask.pause();
	}
	// 取消下载任务 
	function abortDownload() {
		dtask.abort();
	}
	//安装app
	function install(ele, info) {
		var path = getGameinfo(info.pagename);
		console.log("游戏路径" + path)
		if(path != "") {
			plus.runtime.install(path, false, function(Info) {
				//console.log("appid"+Info.appid+"\n版本"+Info.version+"\n名称"+Info.name+"\n描述"+Info.description+"\n应用授权"+Info.license+"\n应用许可"+Info.features);					 	
				var gameinfo = {};
				gameinfo.name = Info.name;
				gameinfo.version = Info.version;
				gameinfo.path=path;
				gameinfo.state = 3
				
				listenInstall(gameinfo,ele);
			
				//TODO 安装包修改状态 未更改
				//						saveGameinfo(gameinfo)
			}, function() {
				ele.innerHTML="下载";
				ele.setAttribute("data-state","1");
				mui.toast("安装包找不到了！请重新下载");
				//安装失败返回函数移除本地缓存的记录
				removeGameinfo(info.name);
			});
		}
	}
	//监听是否安装
	function listenInstall(gameinfo,element)
	{
		var receiver;
	    main = plus.android.runtimeMainActivity();//获取activity
	    receiver = plus.android.implements('io.dcloud.android.content.BroadcastReceiver',{
	        onReceive : function(context,intent){//实现onReceiver回调函数
	        	console.log("<-------apk监听执行方法--------->")
	        		gameinfo.state =3;
					element.removeAttribute("disabled");
					element.setAttribute("data-state", "3");
					element.innerHTML = "打开";
	        plus.android.importClass(intent);//通过intent实例引入intent类，方便以后的‘.’操作
//					        console.log(intent.getAction());//获取action
	        main.unregisterReceiver(receiver);//取消监听
	    }});
	    var IntentFilter = plus.android.importClass('android.content.IntentFilter');
	    var Intent = plus.android.importClass('android.content.Intent');
	    var filter = new IntentFilter();
	    filter.addAction(Intent.ACTION_PACKAGE_ADDED);//监听apk安装
	    filter.addAction(Intent.ACTION_PACKAGE_REMOVED);//监听apk卸载
	    filter.addDataScheme("package");
	    main.registerReceiver(receiver,filter);//注册监听
	}
	
	// 调用第三方程序
	function launchApp(ele, info) { //name 为传递的参数
		console.log(info.pagename)
		if(plus.os.name == "Android") {
			plus.runtime.launchApplication({
				pname:info.pagename
			}, function(e) {
				alert("对不起打开失败: " + e.message);
			});
		} else if(plus.os.name == "iOS") {
			plus.runtime.launchApplication({
				action: "http://www.html5plus.org"
			}, function(e) {
				alert("对不起打开失败: " + e.message);
			});
		}
	}
	//保存游戏信息
	function saveGameinfo(info) {
		var storages = [];
		var stringify = plus.storage.getItem(dow.gameCacheName);
		stringify == null ? stringify = "" : storages = JSON.parse(stringify)
		if(stringify.indexOf(info.name) > 0) {
			for(var i = 0; i < storages.length; i++) {
				if(storages[i].name == info.name && storages[i].version == info.version) {
					storages[i] = info;
				}
			}
		} else {
			storages.push(info);
		}
		var serialize = JSON.stringify(storages);
		console.log("当前对象序列化" + serialize)
				plus.storage.setItem(dow.gameCacheName, serialize);
				var data = plus.storage.getItem(dow.gameCacheName);
				console.log(data);
	};
	//根据包名移除本地游戏缓存
	function removeGameinfo(pagename)
	{
		var storages = [];
		var stringify = plus.storage.getItem(dow.gameCacheName);
		stringify == null ? stringify = "" : storages = JSON.parse(stringify)
		if(stringify.indexOf(pagename) > 0) {
			for(var i = 0; i < storages.length; i++) {
				if(storages[i].name == pagename) {
					storages.splice(i,1)
				}
			}
		}
		console.log(storages+"删除后的数组")
		plus.storage.setItem(dow.gameCacheName,JSON.stringify(storages));	
	}
	
	//根据游戏包名获取游戏下载平台
	function getGamePlatform(pagename)
	{
		var storages = [];
		var stringify = plus.storage.getItem(dow.gameCacheName);
		stringify == null ? stringify = "" : storages = JSON.parse(stringify)
		if(stringify.indexOf(pagename) > 0) {
			for(var i = 0; i < storages.length; i++) {
				if(storages[i].name == pagename) {
					platform = storages[i].platform;
				}
			}
		}
		return platform;
	}
	
	//根据包名获取游戏路径
	function getGameinfo(pagename) {

		var storages = [];
		var stringify = plus.storage.getItem(dow.gameCacheName);
		console.log(stringify);
		stringify == null ? stringify = "" : storages = JSON.parse(stringify)
		if(stringify.indexOf(pagename) > 0) {
			for(var i = 0; i < storages.length; i++) {
				if(storages[i].name == pagename) {
					path = storages[i].path;
				}
			}
		}
		return path;
	}
	//判断是否在本地有安装 如果没有返回false
		app.getappinfo=function(urlID,cacheType)
	{	
		var pagename;
		var cacheList=JSON.parse(plus.storage.getItem(cacheType));
		for(var i=0;i<cacheList.length;i++)
		{
			if(cacheList[i].urlId==urlID)
			{
				pagename=cacheList[i].name;
			}
		}
		console.log(pagename);
		var data={}
	 		try{
				var main = plus.android.runtimeMainActivity();
				var packageManager = main.getPackageManager();
				var PackageManager = plus.android.importClass(packageManager);
				var info =packageManager.getPackageInfo(pagename,0)
				data.versionName=plus.android.getAttribute(info,"versionName")
				data.versionCode=plus.android.getAttribute(info,"versionCode")
				data.packageName=plus.android.getAttribute(info,"packageName")
			}catch(e){
				data=false;
			}
			return data;
	}
	
	//根据缓存判断包名 在缓存中是否有存在 如果存在的话就返回包名对应的 缓存记录 如果没有的话就返回false
	app.isExistAPK=function(urlID,cacheType){
		var pagename;
		var cacheList=JSON.parse(plus.storage.getItem(cacheType));
		for(var i=0;i<cacheList.length;i++)
		{
			if(cacheList[i].urlId==urlID)
			{
				pagename=cacheList[i].name
			}
		}
		console.log(pagename);
		var cache
		var	gamelist=plus.storage.getItem(cacheType)
			gamelist==null?cache="":cache=gamelist 
			if(cache.indexOf(pagename>-1))
			{
				return pagename
			}else{
				return false;
			}
		return cache.indexOf(pagename)>-1;
	}
	app.BrowserDownload=function(info){
			var Intent = plus.android.importClass("android.content.Intent");
		    var Uri = plus.android.importClass("android.net.Uri");
		    // 获取主Activity对象的实例
		    var main = plus.android.runtimeMainActivity();
		    // 创建Intent
		    var uri = Uri.parse(info.href); // 下载地址
		    var browser = new Intent("android.intent.action.VIEW",uri);
		    // 调用startActivity调用浏览器下载
		    main.startActivity( browser );
	}
	/**
	 * 
	 * @param {StringID} element
	 */
	//前台 下载
	dow.init = function(element, info) {
			dow.element = $(element)[0];
			dow.urlId=info.urlId;
			dow.gameCacheName=info.gameCacheName||"gamelist";
			console.log(dow.element+"前台传递元素");
			console.log(JSON.stringify(info)+"前台传递数据")
			createDownload(info);
		},
		//前台 打开
	dow.launchApp = function(element, info) {
			var ele = $(element)[0];
			launchApp(ele, info);
		}
		//前台 安装
	dow.install = function(element, info) {
		var ele = $(element)[0];
		console.log(info.pagename)
		dow.gameCacheName=info.gameCacheName||"gamelist";
		install(ele, info);
	}
	app.download = dow;
	
	//url 为下载的地址
	app.groudDownloading=function(gameinfo){
				mui.fire(main,"getUrl",{gameinfo:gameinfo});
	}
})(mui, window, app = window.app || {});

//app.download.init()